/**
 * @class Node
 *
 * A DOM node. [See the DOM specification for more](http://www.w3.org/TR/dom/#node).
 */

/**
 * @class CharacterData
 * @extends Node
 *
 * Some character data, usually a string. [See the DOM specification for more](http://www.w3.org/TR/dom/#characterdata).
 */

/**
 * @class TextNode
 * @extends CharacterData
 *
 * A text node. [See the DOM specification for more](http://www.w3.org/TR/dom/#text).
 */

/**
 * @class CommentNode
 * @extends CharacterData
 *
 * A comment node. [See the DOM specification for more](http://www.w3.org/TR/dom/#comment).
 */

/**
 * @class Element
 * @extends Node
 *
 * An HTML element. [See the DOM specification for more](http://www.w3.org/TR/dom/#element).
 */

/**
 * @class EventEmitter
 *
 * An event-emitting object. [See the Node.js documentation for more](http://nodejs.org/api/events.html#events_class_events_eventemitter).
 */

/**
 * @class Response
 *
 * A Response object for the express application. [See the express documentation for more](http://expressjs.com/api.html#res.status).
 */

/**
 * @class Request
 *
 * A Request object for the express application. [See the express documentation for more](http://expressjs.com/api.html#req.params).
 */

